#include <avr/io.h>
#include <stdlib.h>



void uart_putc(char c) {

	loop_until_bit_is_set(UCSR0A, UDRE0); //UDRErbg1ɂȂ܂ő҂
	UDR0 = c;					//f[^uartɏo͂

}


void set_sprite(unsigned char n,unsigned char x,unsigned char y,unsigned char p) {

	uart_putc(n*3);		//Ԗڂ̂wW
	uart_putc(x);		//@w
	uart_putc(n*3+1);	//Ԗڂ̂xW
	uart_putc(y);		//@w
	uart_putc(n*3+2);	//Ԗڂ̃p^[ԍ
	uart_putc(p);		//@w
}


void clear_all_sprite(void) {

	int i;

	for (i=0;i<25;i++) {
		set_sprite(i,0,0,0);
	}
}


int button_push() {
								//{^܂ő҂A
								//̌㗣܂ő҂
	int input_D;
	int p_no;

	/*****  <step1>  *****/
								//{^ĂȂΌJԂ
								//{^͕_FȂ΂P
	input_D = PIND;
	while ((input_D & 0b11111100) == 0b11111100) {
								//1łrbgĂ邩`FbN
		input_D = PIND;
	}

	p_no = input_D & 0b11111100;


	/*****  <step2>  *****/
								//{^ĂԌJԂ
								//{^͕_FĂ΂O
	input_D = PIND;
	while ((input_D & 0b11111100) != 0b11111100) {
								//1łrbgĂ邩`FbN
		input_D = PIND;
	}

	return p_no;
}


void background(int x,int y,int p_no)
{
	uart_putc(75);		//ꃌWX^i75=UARToCpXpj
	uart_putc(y*16 + x);	//wWAxW̍o͂

	uart_putc(75);		//ꃌWX^i75=UARToCpXpj
	uart_putc(p_no);	//wiԍo͂

}


void beep(uint16_t tone)
{
	int i;
	uint16_t j;

	for(i=0;i<127;i++) {			//usbvo
		PORTB  = PORTB | _BV(PB2);	//portbpb21o
		for(j=0;j<tone;j++);
		PORTB  = PORTB & ~_BV(PB2);	//portbpb20o
		for(j=0;j<tone;j++);
	}
}


int rnd_c()
{
	return (rand() / (32768/16));	//0`1516̗̐
}




int main(void)
{
	int i,k;
	uint16_t j;

	int v_off;
	int h_off;


	/*****  ݒ  *****/

	DDRD = 0b00000011;	//ocQ`V͂ɃZbg
	DDRB = 0b11111111;	//a|[gׂďo̓[h

	UCSR0B = 0;			//܂AUfB[[uɐݒ
	UCSR0A = 0;			//UׂăNA

	UCSR0C = (1<<UCSZ01)|(1<<UCSZ00);	//8rbgAmpAXgbvP

    UBRR0H = 0x00;
    UBRR0L = 0x0A;			//0x000A = 10 (115.2kbps(20MHz))
							//0x0040 = 64 (19200bps (20MHz))    

    UCSR0B = (1<<TXEN0);	//ݒ芮ɁAMCl[uɐݒ
	 


	uart_putc(0xff);	//0xff𑗂āAf[^V[PXNA




	/*****  C  *****/


	for (k=0;k<10;k++) {
		for (j=0;j<3000;j++);
	}		//XvCgƔwi̋N҂



	background(0,15,5);			//wi􂢑ւ
	clear_all_sprite();

	set_sprite(0,96,56,15);



	for (;;) {


		/*****  fPFXN[  *****/


		h_off = 0;		//XN[ItZbg@l


		button_push();  //L[͑҂


		for (i=1;i<=32;i++) {

			h_off++;

			if (h_off%8 == 0) {			//wiXN[
				background(0,13,8);	//ItZbgNAXN[
				background(15,0,rnd_c());	//ȍ~As𖄂߂鏈
				background(15,1,rnd_c());
				background(15,2,rnd_c());
				background(15,3,rnd_c());
				background(15,4,rnd_c());
				background(15,5,rnd_c());
				background(15,6,rnd_c());
				background(15,7,rnd_c());
				background(15,8,rnd_c());
				background(15,9,rnd_c());
				background(15,10,rnd_c());
				background(15,11,rnd_c());
			} else {
				background(0,13,h_off%8);	//XN[
			}

			for (k=0;k<10;k++) {
				for (j=0;j<3000;j++);
			}		//  ԉ҂

		}



		/*****  fQFEXN[  *****/


		h_off = 32;		//XN[ItZbg@l


		button_push();  //L[͑҂


		for (i=1;i<=32;i++) {

			h_off--;

			if (h_off == -1) {
				h_off = 7;
			}

			if (h_off%8 == 7) {			//wiXN[
				background(0,13,9);	//ItZbgNAEXN[
				background(0,0,rnd_c());	//ȍ~As𖄂߂鏈
				background(0,1,rnd_c());
				background(0,2,rnd_c());
				background(0,3,rnd_c());
				background(0,4,rnd_c());
				background(0,5,rnd_c());
				background(0,6,rnd_c());
				background(0,7,rnd_c());
				background(0,8,rnd_c());
				background(0,9,rnd_c());
				background(0,10,rnd_c());
				background(0,11,rnd_c());
			} else {
				background(0,13,h_off%8);	//EXN[
			}

			for (k=0;k<10;k++) {
				for (j=0;j<3000;j++);
			}		//  ԉ҂

		}



		/*****  fRFXN[  *****/


		v_off = 32;		//cXN[ItZbg@l


		button_push();  //L[͑҂


		for (i=1;i<=32;i++) {

			v_off++;

			if (v_off%8 == 0) {			//wiXN[
				background(0,14,8);	//ItZbgNAXN[
				background(0,11,rnd_c());	//ȍ~As𖄂߂鏈
				background(1,11,rnd_c());
				background(2,11,rnd_c());
				background(3,11,rnd_c());
				background(4,11,rnd_c());
				background(5,11,rnd_c());
				background(6,11,rnd_c());
				background(7,11,rnd_c());
				background(8,11,rnd_c());
				background(9,11,rnd_c());
				background(10,11,rnd_c());
				background(11,11,rnd_c());
				background(12,11,rnd_c());
				background(13,11,rnd_c());
				background(14,11,rnd_c());
			} else {
				background(0,14,v_off%8);
			}

			for (k=0;k<10;k++) {
				for (j=0;j<3000;j++);
			}		//  ԉ҂


		}



		/*****  fSFXN[  *****/

		v_off = 32;		//cXN[ItZbg@l


		button_push();  //L[͑҂


		for (i=1;i<=32;i++) {

			v_off--;

			if (v_off == -1) {
				v_off = 7;
			}

			if (v_off%8 == 7) {			//wiXN[
				background(0,14,9);	//ItZbgNAXN[
				background(0,0,rnd_c());	//ȍ~As𖄂߂鏈
				background(1,0,rnd_c());
				background(2,0,rnd_c());
				background(3,0,rnd_c());
				background(4,0,rnd_c());
				background(5,0,rnd_c());
				background(6,0,rnd_c());
				background(7,0,rnd_c());
				background(8,0,rnd_c());
				background(9,0,rnd_c());
				background(10,0,rnd_c());
				background(11,0,rnd_c());
				background(12,0,rnd_c());
				background(13,0,rnd_c());
				background(14,0,rnd_c());
			} else {
				background(0,14,v_off%8);
			}

			for (k=0;k<10;k++) {
				for (j=0;j<3000;j++);
			}		//  ԉ҂


		}


	}

}

